<template>
  <div class="padding">
    <div class="range-slider">
      <div class="row">
        <div class="columns six">
          <div class="upper-header">Сумма займа:</div>
          <div class="row range-slider__upper-text upper-text">
            <div class="columns seven big">
              <div class="manual-entry">
                {{amount|currency}}
              </div>
              <div class="name-field-amount" :class="{'name-field-amount-min': amount > 9500 ? false : true}">₽</div>
            </div>
            <div class="columns five small">К возврату: <strong>{{ returnAmount }} ₽</strong></div>
          </div>

          <!-- Slider Amount -->

          <div class="range-slider">
            <div ref="track" tabindex="0" class="slider" @mousedown="trackClick" @keydown.left.right="movement">
              <div class="color" ref="pathway" :style="widthStyleAmount"></div>
              <div class="bumper"
                   :style="leftStyleAmount"
                   ref="circle"
                   @mousedown.prevent="decline"
                   @touchstart="decline"
              ></div>
            </div>
            <div class="column liner"></div>
            <div class="row range">
              <div class="columns six">
                {{rate2.sum_min}}
              </div>
              <div class="columns six right">
                {{ rate2.sum_max }}
              </div>
            </div>
          </div>

          <!---->

        </div>

        <div class="columns six">
          <div class="upper-header">Срок займа:</div>
          <div class="row range-slider__upper-text upper-text">
            <div class="columns seven big">
              <div class="manual-entry">
                {{overDate}}
              </div>
              <div class="name-field-days">
                {{ $helpers.plural(overDate, amount > 20000 ? ['месяц', 'месяца', 'месяцев'] : ['день', 'дня', 'дней']) }}
              </div>
            </div>
            <div class="columns five small">Дата возврата: <strong>{{ shouldReturnDate }}</strong></div>
          </div>

          <!--Slider Date-->

          <div class="range-slider">
            <div ref="trackDate" tabindex="0" class="slider" @mousedown="dateClick" @keydown.left.right="traffic">
              <div class="color" ref="pathway" :style="widthStyleDate"></div>
              <div class="bumper"
                   :style="leftStyleDate"
                   ref="circle"
                   @mousedown.prevent="falling"
                   @touchstart="falling"
              ></div>
            </div>
            <div class="column liner"></div>
            <div class="row range">
              <div class="columns six" v-if="amount <= 20000">
                {{periodMin}}
              </div>
              <div class="columns six right" v-if="amount <= 20000">
                {{periodMax}}
              </div>
              <div v-if="amount > 20000">
                <span>3</span>
                <span class="block-month-slider" style="width: 34%">4</span>
                <span class="block-month-slider" style="width: 29%">5</span>
                <span class="block-month-slider" style="float: right">6</span>
              </div>
            </div>
          </div>

          <!---->

        </div>
      </div>
    </div>
  </div>
</template>

<script>
  import {getDateAfterDays, getMonth, num2words} from '@/utils/helpers'

  const roundPercent = (coeff) => {
    if (coeff >= 0 && coeff <= 1) {
      return Math.round(coeff * 1000) / 10
    } else
    if (coeff > 1) { return 100 }
    return 0
  };

  const rangeDate = (coeff) => {
    if (coeff >= 0 && coeff <= 1) {
      return Math.round(coeff * 1000) / 10
    } else
    if (coeff > 1) { return 100 }
    return 0
  };

  let canContinue = true;
  let haveTime = true;

  export default {
    name: 'CreditRate',
    props: ['rate2'],
    data () {
      return {
        flag: false,
        fullOffset: 0,
        fullOfDate: 0,
        amount_percent: (7000 / this.rate2.sum_max) * 100,
        percentage: 0, // (5 / this.rate2.period_max) * 100, - не удалять, ранее была данная формула
        percentStep: Number((100 / (this.rate2.sum_max / 500)).toFixed(2)),
        stepPercentage: Number((100 / (this.rate2.period_max)).toFixed(2)),
        discretePercentAmount: Math.round(this.percentStep * Math.round(this.amount_percent / this.percentStep)),
        discretePercentage: Math.round(this.stepPercentage * Math.round(this.percentage / this.stepPercentage))
      }
    },

    computed: {
      leftStyleAmount () {
        if ((this.amount > 20000) && (this.amount < 25000)) {
          this.amount = 20000
        }
        if ((this.amount > 25000) && (this.amount < 30000)) {
          this.amount = 30000
        }
        return `left: ${this.amount_percent}%;`
      },
      widthStyleAmount () {
        return `width: ${this.amount_percent}%;`
      },
      leftStyleDate () {
        return `left: ${this.percentage}%;`
      },
      widthStyleDate () {
        return `width: ${this.percentage}%;`
      },
      amount () {
        if (500 * Math.round((this.rate2.sum_max - this.rate2.sum_min) * this.amount_percent / 100 / 500) + this.rate2.sum_min <= 20000) {
          return 500 * Math.round((this.rate2.sum_max - this.rate2.sum_min) * this.amount_percent / 100 / 500) + this.rate2.sum_min
        }
        if ((500 * Math.round((this.rate2.sum_max - this.rate2.sum_min) * this.amount_percent / 100 / 500) + this.rate2.sum_min > 20000) && (500 * Math.round((this.rate2.sum_max - this.rate2.sum_min) * this.amount_percent / 100 / 500) + this.rate2.sum_min < 30000)) {
          return 30000;
        }
        if (500 * Math.round((this.rate2.sum_max - this.rate2.sum_min) * this.amount_percent / 100 / 500) + this.rate2.sum_min >= 30000) {
          return 1000 * Math.round((this.rate2.sum_max - this.rate2.sum_min) * this.amount_percent / 100 / 1000) + this.rate2.sum_min
        }
      },
      overDate () {
        return Math.round((this.periodMax - this.periodMin) * this.percentage / 100 ) + this.periodMin
      },
      returnAmount () {
        if (this.amount <= 20000) {
          let percent_sum = 0;
          for(let i = 0;i < this.overDate; i++) {
            percent_sum += this.amount / 100 * this.rate2.period_percents[this.overDate - 1];
          }
          return this.amount + percent_sum
        }
        if (this.amount >= 30000) {
          let dateFrom = this.$dayjs(this.$dayjs(new Date()).format('YYYY-MM-DD'));
          let dateTo = this.$dayjs(this.$dayjs().add(this.overDate, 'months').format('YYYY-MM-DD'));
          let days = dateTo.diff(dateFrom, 'day');
          return this.amount + ((this.amount * days * this.rate2.fix_percent) / 100)
        }
      },
      periodMin () {
        return this.amount > 20000 ? 3 : this.rate2.period_min
      },
      periodMax () {
        return this.amount > 20000 ? 6 : this.rate2.period_max
      },
      shouldReturnDate () {
        if (this.amount > 20000) {
          let month = getMonth(this.$dayjs().add(this.overDate, 'months').format('M'))
          return this.$dayjs().add(this.overDate, 'months').format(`DD ${month} YYYY`)
        }
        return getDateAfterDays(this.overDate)
      },
    },
    methods: {
      getFullOffset (element, sum) {
        if (element.offsetParent) {
          return this.getFullOffset(element.offsetParent, sum + element.offsetLeft)
        }
        return sum
      },
      getFullOfDate (element, date) {
        if (element.offsetParent) {
          return this.getFullOfDate(element.offsetParent, date + element.offsetLeft)
        }
        return date
      },
      calcFullOffset () {
        this.fullOffset = this.getFullOffset(this.$refs.track, 0)
      },
      calcFullOfDate () {
        this.fullOfDate = this.getFullOfDate(this.$refs.trackDate, 0)
      },
      recalculation (e) {
        if (canContinue) {
          this.discretePercentAmount = Math.round(this.percentStep * Math.round(this.amount_percent / this.percentStep));
          const clientX = e.clientX || e.touches[0].clientX;
          this.amount_percent = roundPercent((clientX - this.fullOffset) / this.$refs.track.offsetWidth);
          canContinue = false;
          setTimeout(() => canContinue = true, 25)
        }
      },
      recalendar (e) {
        if (haveTime) {
          this.discretePercentage = Math.round(this.stepPercentage * Math.round(this.percentage / this.stepPercentage));
          const clientX = e.clientX || e.touches[0].clientX;
          this.percentage = rangeDate((clientX - this.fullOfDate) / this.$refs.track.offsetWidth);
          haveTime = false;
          setTimeout(() => haveTime = true, 25)
        }
      },
      trackClick (e) {
        const clientX = e.clientX || e.touches[0].clientX;
        this.amount_percent = roundPercent((clientX - this.fullOffset) / this.$refs.track.offsetWidth);
        if ((this.flag === false) && (this.amount >= 30000)) {
          this.percentage = 0;
          this.flag = true
        }
        if (this.amount <= 20000) {
          this.flag = false
        }
      },
      dateClick (e) {
        const clientX = e.clientX || e.touches[0].clientX;
        this.percentage = rangeDate((clientX - this.fullOfDate) / this.$refs.trackDate.offsetWidth);
        if (this.amount >= 30000) {
          if (this.percentage >= 0 && this.percentage <= 25) {
            this.percentage = 0;
          }
          if (this.percentage >= 26 && this.percentage <= 50) {
            this.percentage = 34;
          }
          if (this.percentage >= 51 && this.percentage <= 75) {
            this.percentage = 64;
          }
          if (this.percentage >= 76 && this.percentage <= 100) {
            this.percentage = 100;
          }
        }
      },
      movement (event) {
        if (event.key === 'ArrowRight') this.amount_percent = roundPercent((Number(this.amount_percent) + Number(this.percentStep)) / 100);
        if (event.key === 'ArrowLeft') this.amount_percent = roundPercent((Number(this.amount_percent) - Number(this.percentStep)) / 100)
      },
      traffic (event) {
        if (event.key === 'ArrowRight') {
          this.percentage = rangeDate((Number(this.percentage) + Number(this.percentStep)) / 100);
        }
        if (event.key === 'ArrowLeft') {
          this.percentage = rangeDate((Number(this.percentage) - Number(this.percentStep)) / 100)
        }
      },
      mouseUp () {
        this.$emit('mouseup');
        document.removeEventListener('mousemove', this.recalculation);
        document.removeEventListener('touchmove', this.recalculation);
        document.removeEventListener('mouseup', this.mouseUp);
        document.removeEventListener('touchend', this.mouseUp);
        this.amount_percent = this.discretePercentAmount;
        if ((this.flag === false) && (this.amount >= 30000)) {
          this.percentage = 0;
          this.flag = true
        }
        if (this.amount_percent > 39 && this.amount_percent < 50) {
          this.amount_percent = 39
        }
        if (this.amount_percent >= 50 && this.amount_percent < 60) {
          this.amount_percent = 60
        }
        if (this.amount <= 20000) {
          this.flag = false
        }
      },
      mouseUpDate () {
        this.$emit('mouseup');
        document.removeEventListener('mousemove', this.recalendar);
        document.removeEventListener('touchmove', this.recalendar);
        document.removeEventListener('mouseup', this.mouseUpDate);
        document.removeEventListener('touchend', this.mouseUpDate);
        this.percentage = this.discretePercentage;
        if (this.amount >= 30000) {
          if (this.percentage >= 0 && this.percentage <= 25) {
            this.percentage = 0;
          }
          if (this.percentage >= 26 && this.percentage <= 50) {
            this.percentage = 34;
          }
          if (this.percentage >= 51 && this.percentage <= 75) {
            this.percentage = 64;
          }
          if (this.percentage >= 76 && this.percentage <= 100) {
            this.percentage = 100;
          }
        }
      },
      decline (event) {
        event.stopPropagation();
        this.calcFullOffset();
        this.$refs.track.focus();
        event.preventDefault();
        document.addEventListener('mousemove', this.recalculation);
        document.addEventListener('touchmove', this.recalculation);
        document.addEventListener('mouseup', this.mouseUp);
        document.addEventListener('touchend', this.mouseUp)
      },
      falling (event) {
        event.stopPropagation();
        this.calcFullOfDate();
        this.$refs.trackDate.focus();
        event.preventDefault();
        document.addEventListener('mousemove', this.recalendar);
        document.addEventListener('touchmove', this.recalendar);
        document.addEventListener('mouseup', this.mouseUpDate);
        document.addEventListener('touchend', this.mouseUpDate)
      }
    },
    mounted () {
      this.calcFullOffset();
      this.calcFullOfDate();
    },
    created () {
      if (this.$cookie.get('loanSum') !== null) {
        if (this.$cookie.get('loanSum') !== 0) {
          let amount = 0;
          if (this.$cookie.get('loanSum') === 1000) {
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 1500) {
            amount = 500;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 2000) {
            amount = 1000;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 2500) {
            amount = 1500;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 3000) {
            amount = 2000;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 3500) {
            amount = 2500;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 4000) {
            amount = 3000;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 4500) {
            amount = 3500;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 5000) {
            amount = 4500;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 5500) {
            amount = 5000;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 6000) {
            amount = 5500;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 6500) {
            amount = 6000;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 7000) {
            amount = 6500;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 7500) {
            amount = 7000;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 8000) {
            amount = 7500;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 8500) {
            amount = 8000;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 9000) {
            amount = 8500;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 9500) {
            amount = 9000;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 10000) {
            amount = 9500;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 10500) {
            amount = 10000;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanSum') === 11000) {
            amount = 10500;
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
          if ((this.$cookie.get('loanSum') >= 11500) && (this.$cookie.get('loanSum') >= 20000)) {
            amount = parseInt(this.$cookie.get('loanSum'));
            this.amount_percent = (amount / this.rate2.sum_max) * 100;
          }
        }
      }

      if (this.$cookie.get('loanDays') !== null) {
        if (this.$cookie.get('loanDays') !== 0) {
          let date = 0;
          if (this.$cookie.get('loanDays') === 5) {
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 6) {
            date = 1;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 7) {
            date = 2;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 8) {
            date = 3;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 9) {
            date = 5;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 10) {
            date = 6;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 11) {
            date = 7;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 12) {
            date = 8;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 13) {
            date = 9;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 14) {
            date = 11;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 15) {
            date = 12;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 16) {
            date = 13;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 17) {
            date = 14;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 18) {
            date = 15;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 19) {
            date = 17;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 20) {
            date = 18;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 21) {
            date = 19;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 22) {
            date = 20;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 23) {
            date = 21;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 24) {
            date = 23;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 25) {
            date = 24;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 26) {
            date = 25;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 27) {
            date = 26;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 28) {
            date = 27;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 29) {
            date = 29;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
          if (this.$cookie.get('loanDays') === 30) {
            date = 30;
            this.percentage = (date / this.rate2.sum_max) * 100;
          }
        }
      }
    },
  }
</script>

<style scoped lang="scss">
  .range {
    & div {
      box-sizing: border-box;
      & span.block-month-slider {
        box-sizing: border-box;
        text-align: right;
        display: inline-block;
        &:first-child {
        }
      }
    }
  }
  .text-red {
    color: #ff3e3e !important;
  }
  .name-field-amount-min {
    left: 90px;
  }
  .name-field-days {
    left: 4px !important;
  }
</style>
